struct result DE (struct param param, struct problem pb) 
{  
	double C;
	int d; 
	int dRand;

	double error;   
	double errorPrev;
	double F;
//	double fi[S_max];
	int i;
	int improvNb;
	int improv[S_max];
	int index[S_max];     
	int iter; 		// Iteration number (time step)
	int iterBegin;
	
	int l; 
	int noStop;
	double out;

	struct result R;
	int s0, s, sRand; 
	int sr[S_max];
	struct vector V={0};  
	struct position X4, X5;
	double xMax,xMin;
	double zz;

	V.size=pb.SS.D;
	X4.size=pb.SS.D;
	X5.size=pb.SS.D;

	// -----------------------------------------------------
	// INITIALISATION
	R.SW.S = param.S; // Size of the current swarm

	// Personal parameters (useful only for some options)
	for (s = 0; s < R.SW.S; s++)   
	{
		R.SW.F[s]=param.F; //alea(param.F,2);
		R.SW.C[s]=param.C; //alea(param.C,1);		
		R.SW.improv[s]=1;
	}

	// Positions
	if(pb.SS.normalise>0) {xMin=0; xMax=pb.SS.normalise;} // [0,normalise]^D

	for (s = 0; s < R.SW.S; s++)   
	{
		R.SW.X[s].size = pb.SS.D;
		for (d = 0; d < pb.SS.D; d++)  
		{  
			if(pb.SS.normalise==0) { xMin=pb.SS.min[d]; xMax=pb.SS.max[d];}
			R.SW.X[s].x[d] = alea (xMin,xMax);		
		}
	}

	// Take quantisation into account
	if(pb.SS.quantisation==1)
	{
		for (s = 0; s < R.SW.S; s++)
		{  
			R.SW.X[s] = quantis (R.SW.X[s], pb.SS);
		}
	}

	// First evaluations
	errMax=0;
	errMin=infinity;
	for (s = 0; s < R.SW.S; s++) 
	{	
		R.SW.X[s].f =
			perf (R.SW.X[s], pb.function,pb.SS,pb.objective);
		// Memorise
		R.SW.P[s]=R.SW.X[s]; // Useful only in case of DE+PSO (BW[1]=10)	
	}

	//
	// If the number max of evaluations is smaller than 
	// the swarm size, just keep evalMax particles, and finish
	if (R.SW.S>pb.evalMax) R.SW.S=pb.evalMax;	
	R.nEval = R.SW.S;

	// Find the best
	R.SW.best = 0;

	errorPrev =R.SW.X[R.SW.best].f; // "distance" to the wanted f value (objective)

	for (s = 1; s < R.SW.S; s++)     
	{
		zz=R.SW.X[s].f;
		if (zz < errorPrev)
		{
			R.SW.best = s;
			errorPrev=zz;
		} 
	}

	// Display the best
	//printf( "\nBest value after init. %1.20e ", errorPrev );
	//	printf( "\n Position :\n" );
	//	for ( d = 0; d < pb.SS.D; d++ ) printf( " %f", R.SW.X[R.SW.best].x[d] );

	// ---------------------------------------------- ITERATIONS	
	noStop = 0;	
	error=errorPrev;	
	iter=0; iterBegin=0;
	F=param.F;
	//F=(6*pb.SS.D+1)/(3*pb.SS.D+2);
	C=param.C;
	improvNb=0;

	while (noStop == 0) 
	{	
		iter=iter+1;
		//printf("\n Iteration %i",iter);	
		for(s=0;s<R.SW.S;s++) improv[s]=0;
	
		// Loop on particles
		for (s = 0; s < R.SW.S; s++)	// For each particle ...
		{	
			// Choose at random three other ones
			l=R.SW.S;
			for(s0=0;s0<l;s0++) index[s0]=s0;		
			sRand=s;	
			for(i=0;i<3;i++)
			{
				// Compact index		
				if(sRand<l-1)
				{
					for(s0=sRand;s0<l-1;s0++)
					{ 
						index[s0]=index[s0+1];
					}
				}
				l=l-1;
				sRand=alea_integer(0,l-1); sr[i]=index[sRand];
			}	
			
			// Donor position X4
					for (d = 0; d < pb.SS.D; d++)
					{
						X4.x[d]=R.SW.X[sr[0]].x[d]+F*(R.SW.X[sr[1]].x[d]-R.SW.X[sr[2]].x[d]);
					}
					
			// Trial position X5
			switch(param.BW[1])
			{	
				case 0: // Standard DE 	
					dRand=alea_integer(0,pb.SS.D-1);
					for (d=0;d<pb.SS.D;d++)
				{
					if(alea(0,1)<C || d==dRand) X5.x[d]=X4.x[d];
					else X5.x[d]=R.SW.X[s].x[d];
				}
					break;

					case 1: // Linear DE 
					// Simulate a Binomial distribution
					zz=alea_binom(C,pb.SS.D);
		
						for (d = 0; d < pb.SS.D; d++) 
					{		
						X5.x[d]=R.SW.X[s].x[d]+zz*(X4.x[d]-R.SW.X[s].x[d]);		
					}
				}	
			// --------------------------

			if(pb.SS.quantisation==1)
				X5 = quantis (X5, pb.SS);

			// Confinement			
			out=0;
			switch(param.confin)
			{
				default: 
					for (d = 0; d < pb.SS.D; d++)
				{	
					if(pb.SS.normalise==0) { xMin=pb.SS.min[d]; xMax=pb.SS.max[d];}

					if (X5.x[d] < xMin)
					{	
						X5.x[d] = xMin;
						out=1;
					}
					else
					{
						if (X5.x[d] > xMax)
						{			
							X5.x[d] = xMax;
							out=1;
						}
					}				
				}	
					break;

					case 1: // No confinement and no evaluation if outside ("let if fly")
						for (d = 0; d < pb.SS.D; d++)
				{	
					if(pb.SS.normalise==0) { xMin=pb.SS.min[d]; xMax=pb.SS.max[d];}

					if (X5.x[d] < xMin || X5.x[d] > xMax) out=1;		
				}	
					break;
			}

			if(pb.SS.quantisation==1 && out>0)
			{
				X5 = quantis (X5, pb.SS);		
			}		
			// If the position is inside
			if(param.confin==0 || (param.confin==1 && out<zero))
			{
				// Evaluation
				X5.f =perf(X5,pb.function, pb.SS,pb.objective);
				R.nEval = R.nEval + 1;				
				if (R.nEval > pb.evalMax)  goto end;

				// ... update position (Selection)

						if (X5.f <= R.SW.X[s].f)	
					{								
						R.SW.X[s] = X5;	
						R.SW.improv[s]++; // Better "quality"
							// TO TEST: improve instead the quality of sr[0], sr[1], sr[2]
							improv[s]++; // This particle (agent) has improved its position during this iteration
					}
				// ... update the best known position
						if(X5.f<R.SW.X[R.SW.best].f) 
					{
						error=X5.f;
						R.SW.best=s;
						improvNb++;
					}
			}
		}			// End of "for (s0=0 ...  "	

		errorPrev = error;
		
		
		end:

			if (error > pb.epsilon && R.nEval < pb.evalMax)
		{
			noStop = 0;	// Won't stop
		}
			else
		{
			noStop = 1;	// Will stop
		}


	} // End of "while nostop ...
	

	// printf( "\n and the winner is ... %i", R.SW.best );

	R.error = error;
	return R;  
}
// ===========================================================
struct position quantis (struct position x, struct SS SS ) 
{     
	/*
	 Quantisation of a position
	 Only values like x+k*q (k integer) are admissible 
		 */ 
	int d;
	double qd;
	struct position quantx;

	quantx = x;     
	for (d = 0; d < x.size; d++)
	{
		qd = SS.q.q[d];	

		if (qd > zero)	// Note that qd can't be < 0
		{           				
			quantx.x[d] = qd * floor (0.5 + x.x[d] / qd);	    
		}	
	}
	return quantx;    
}


